Subject: Re: [PATCH v3 2/2][BNX2]: Add iSCSI support to BNX2 devices.

From: Jeff Garzik <[email-masked]>
Date: Thu, 27 Sep 2007 04:23:14 -0400

FUJITA Tomonori wrote:
> CC'ed Jens, James, and linux-scsi.
> 
> On Thu, 27 Sep 2007 03:31:55 -0400
> Jeff Garzik <[email-masked]> wrote:
> 
>> FUJITA Tomonori wrote:
>>> Yeah, we could nicely handle lld's restrictions (especially with
>>> stacking devices). But iommu code needs only max_segment_size and
>>> seg_boundary_mask, right? If so, the first simple approach to add two
>>> values to device structure is not so bad, I think.
>> (replying to slightly older email in the thread)
>> (added benh, since we've discussed this issue in the past)
>>
>> dumb question, what happened to seg_boundary_mask?
> 
> I'll work on it too after finishing max_seg_size.
> 
> 
>> If you look at drivers/ata/libata-core.c:ata_fill_sg(), you will note 
>> that we split s/g segments after DMA-mapping.  Looking at libata LLDD's, 
>> you will also note judicious use of ATA_DMA_BOUNDARY (0xffff).
> 
> I know the workaround since I fixed libata's sg chaining patch.
> 
> 
>> It was drilled into my head by James and benh that I cannot rely on the 
>> DMA boundary + block/scsi + dma_map_sg() to ensure that my S/G segments 
>> never cross a 64K boundary, a legacy IDE requirement.  Thus the 
>> additional code in ata_fill_sg() to split S/G segments straddling 64K, 
>> in addition to setting dma boundary to 0xffff.
> 
> I think that the block layer can handle both max_segment_size and
> seg_boundary_mask properly (and SCSI-ml just uses the block layer). So
> if we fix iommu, then we can remove a workaround to fix sg lists in
> llds.
> 
> 
>> A key problem I was hoping would be solved with your work here was the 
>> elimination of that post dma_map_sg() split.
> 
> Yeah, that's my goal too.

Great :)  Well, I'm generally happy with your max-seg-size stuff (sans 
the minor nits I pointed out in another email).

Thanks for pursuing this,

	Jeff